﻿Imports System.ComponentModel


Public Class CC_NumBox
   Inherits TextBox

#Region "erzeugte Events"
   Public Event AllErrClear(sender As Control)
   Public Event CtrlErr(sender As Control, ErrText As String)
#End Region 'erzeugte Events


#Region "Class-Objekte mit Events"
   Public WithEvents myContext_Menu As NumBox_KontextMenu
#End Region 'Class-Objekte mit Events


#Region "Variablen"
   Private NumberFormatInfo As Globalization.NumberFormatInfo = System.Globalization.CultureInfo.CurrentCulture.NumberFormat
   Private DecimalSeparator As String = NumberFormatInfo.NumberDecimalSeparator
   Private GroupSeparator As String = NumberFormatInfo.NumberGroupSeparator
   Private NegativeSign As String = NumberFormatInfo.NegativeSign

   Private AllUndoValues As New List(Of String)

   Private bytDecimal_Places As Byte = 0
   Private strErrText As String = String.Empty
   Private colHighlight_Color As Color = Color.Red
   Private bolMinus_Allowed As Boolean = False
   Private strMinValue As String = String.Empty
   Private strMaxValue As String = String.Empty
   Private colNormal_Color As Color = Color.Gainsboro
   Private strOld_Value As String = String.Empty
   Private intPen_Width As Integer = 1
   Private bolTausender As Boolean = False
   'statt Konstante:
   Private ErrDecPlaces As String = "Es sind nur " & myDecimal_Places.ToString & " Nachkommastellen erlaubt!"
#End Region


#Region "Konstanten"
   Private Const ErrNoDecPlaces As String = "Dezimal-Werte sind nicht zulässig!"
   Private Const ErrDezKommaDa As String = "Das Dezimal-Komma ist bereits vorhanden!"
   Private Const ErrNoNegs As String = "Negativ-Werte sind nicht zulässig!"
   Private Const ErrNegDa As String = "Das Negativ-Zeichen ist bereits vorhanden!"
   Private Const ErrNoNegHier As String = "Das Negativ-Zeichen kann an dieser Stelle nicht gesetzt werden!"
   Private Const ErrNoBetween As String = "Der Wert liegt nicht innerhalb der zulässigen Werte!"
#End Region 'Konstanten


   '***************************************************************************************************************************
#Region "Constructor"
   '***************************************************************************************************************************
   Public Sub New()
      MyBase.New()
      'Call InitializeComponent()
      With Me
         .Height = 22
         .BackColor = Color.White
         .TabStop = True : .TabIndex = 0
         .WordWrap = False
      End With 'Me
      Me.ContextMenu = New NumBox_KontextMenu
   End Sub 'New

#End Region 'Constructor
   '***************************************************************************************************************************


   '***************************************************************************************************************************
#Region "Public Properties"
   '***************************************************************************************************************************
   ''' <summary>
   ''' Rahmenfarbe wenn Ctrl Focus hat
   ''' </summary>
   <Description("Color für den Rahmen im Status Highlight"), Category("Xtra")> _
   Public Property myColor_HighLight() As Color
      Get
         myColor_HighLight = colHighlight_Color
      End Get
      Set(AktValue As Color)
         colHighlight_Color = AktValue
      End Set
   End Property 'myColor_HighLight


   ''' <summary>
   ''' Rahmenfarbe wenn Ctrl Focus hat
   ''' </summary>
   <Description("Color für den Rahmen im Status Normal"), Category("Xtra")> _
   Public Property myColor_Basis() As Color
      Get
         myColor_Basis = colNormal_Color
      End Get
      Set(AktValue As Color)
         colNormal_Color = AktValue
      End Set
   End Property 'myColor_Basis


   ''' <summary>
   ''' erlaubte Dezimalstellen
   ''' </summary>
   <Description("Dezimalstellen"), DisplayName("Dezimalstellen"), Category("Xtra")> _
   Public Property myDecimal_Places() As Byte
      Get
         myDecimal_Places = bytDecimal_Places
      End Get
      Set(AktValue As Byte)
         bytDecimal_Places = AktValue
      End Set
   End Property 'myDecimal_Places


   ''' <summary>
   ''' größstmögliche Wert
   ''' </summary>
   <Description("größstmögliche Wert"), DisplayName("Maximum"), Category("Xtra")> _
   Public Property myMaxValue() As String
      Get
         myMaxValue = strMaxValue
      End Get
      Set(AktValue As String)
         If (AktValue = String.Empty) Then
            strMaxValue = AktValue
         Else
            If Not (myMinValue = String.Empty) AndAlso CDbl(AktValue) < CDbl(myMinValue) Then
               MessageBox.Show("Fehlerhafte Eingabe!", Me.Name, MessageBoxButtons.OK, MessageBoxIcon.Error)
               Me.Text = myOld_Value
            Else
               strMaxValue = AktValue
            End If
         End If
      End Set
   End Property 'myMaxValue


   ''' <summary>
   ''' Bindestrich/Minuszeichen erlaubt
   ''' </summary>
   <Description("Minuszeichen zulässig"), DisplayName("Minus-Werte"), Category("Xtra")> _
   Public Property myMinus_Allowed() As Boolean
      Get
         myMinus_Allowed = bolMinus_Allowed
      End Get
      Set(AktValue As Boolean)
         bolMinus_Allowed = AktValue
      End Set
   End Property 'myMinus_Allowed


   ''' <summary>
   ''' kleinstmögliche Wert
   ''' </summary>
   <Description("kleinstmögliche Wert"), DisplayName("Minimum"), Category("Xtra")> _
   Public Property myMinValue() As String
      Get
         myMinValue = strMinValue
      End Get
      Set(AktValue As String)
         If (AktValue = String.Empty) Then
            strMinValue = AktValue
         Else
            If Not (myMaxValue = String.Empty) AndAlso CDbl(AktValue) > CDbl(myMaxValue) Then
               MessageBox.Show("Fehlerhafte Eingabe!", Me.Name, MessageBoxButtons.OK, MessageBoxIcon.Error)
               Me.Text = myOld_Value
            Else
               strMinValue = AktValue
            End If
         End If
      End Set
   End Property 'myMinValue


   ''' <summary>
   ''' Rahmenstärke wenn Ctrl Focus hat
   ''' </summary>
   <Description("Rahmenstärke des Rahmens mit Highlight Color"), DisplayName("Rahmenstärke (in dpi"), Category("Xtra")> _
   Public Property myPen_Width() As Integer
      Get
         myPen_Width = intPen_Width
      End Get
      Set(AktValue As Integer)
         intPen_Width = AktValue
      End Set
   End Property 'myPen_Width


   ''' <summary>
   ''' größstmögliche Wert
   ''' </summary>
   <Description("Tausenderpunkt setzen"), DisplayName("Tausenderpunkt"), Category("Xtra")> _
   Public Property myTausenderPunkt() As Boolean
      Get
         myTausenderPunkt = bolTausender
      End Get
      Set(AktValue As Boolean)
         bolTausender = AktValue
      End Set
   End Property 'myTausenderPunkt


#End Region 'Public Properties
   '***************************************************************************************************************************

   '***************************************************************************************************************************
#Region "Private Properties"
   '***************************************************************************************************************************
   ''' <summary>
   ''' ErrText - löst Event aus
   ''' </summary>
   Private Property myErr_Text() As String
      Get
         myErr_Text = strErrText
      End Get
      Set(AktValue As String)
         strErrText = AktValue
         RaiseEvent CtrlErr(sender:=Me, ErrText:=AktValue)
      End Set
   End Property 'myErr_Text


   ''' <summary>
   ''' alter Wert bei Eintritt ins Feld
   ''' </summary>
   Private Property myOld_Value() As String
      Get
         myOld_Value = strOld_Value
      End Get
      Set(AktValue As String)
         strOld_Value = AktValue
      End Set
   End Property 'myOld_Value

#End Region 'Private Properties
   '***************************************************************************************************************************


   '***************************************************************************************************************************
#Region "Aktivität bei Enter, GotFocus, LostFocus und Leave der Textbox"
   '***************************************************************************************************************************
   ''' <summary>
   ''' OnEnter: Cursor positionieren + Rahmen zeichnen
   ''' </summary>
   Protected Overrides Sub OnEnter(e As EventArgs)
      Dim tmpUndos As Integer = -1

      Try
         myOld_Value = Me.Text

         'UndoValue setzen
         With AllUndoValues
            If IsNothing(tmpUndos) Then
               tmpUndos = 0
            Else
               tmpUndos = .Count
            End If
            If tmpUndos = 0 Then
               .Add(Me.Text)
            ElseIf Not (Me.Text = .Item(tmpUndos - 1)) Then
               .Add(Me.Text)
            End If
         End With 'AllUndoValues

         'CursorPositionierung
         With Me
            Select Case Routinen.CursorPosition
               Case 1
                  .SelectionStart = 0 : .SelectionLength = 0
               Case 2
                  .SelectionStart = 0 : .SelectionLength = .TextLength
               Case 3
                  .SelectionStart = .TextLength : .SelectionLength = 0
            End Select 'PWClass.CursorPosition
         End With 'Me
      Catch ex As Exception
         Call Routinen.ErrMeldung(ex:=ex)
      End Try
      MyBase.OnEnter(e)
   End Sub 'OnEnter


   ''' <summary>
   ''' OnClick: Focus auf Parent-Form des Controls setzen
   ''' </summary>
   Protected Overrides Sub OnClick(e As EventArgs)
      Try
         Me.FindForm.Focus()
      Catch ex As Exception
         Call Routinen.ErrMeldung(ex:=ex)
      End Try
      MyBase.OnClick(e)
   End Sub


   ''' <summary>
   ''' OnLeave: evt Fehler-Zeichen + Rahmen löschen
   ''' </summary>
   Protected Overrides Sub OnLeave(e As EventArgs)
      Try
         Call Set_Focused_Color()
         RaiseEvent AllErrClear(sender:=Me)
      Catch ex As Exception
         Call Routinen.ErrMeldung(ex:=ex)
      End Try
      MyBase.OnLeave(e)
   End Sub 'OnLeave

#End Region 'Enter, GotFocus, LostFocus und Leave
   '***************************************************************************************************************************


   '***************************************************************************************************************************
#Region "Verarbeitung der gedrückten Taste in der Textbox - KeyDown, KeyPress"
   '***************************************************************************************************************************
   ''' <summary>
   ''' OnKeydown
   ''' steuert das Verhalten des Cursors bei Eingabe einer Steuertaste z.B: sendet bei Enter einen Tab zum Controlwechsel
   ''' </summary>
   Protected Overrides Sub OnKeydown(e As KeyEventArgs)
      Try
         With Me
            Select Case e.KeyData
               Case Keys.Return, Keys.Down
                  SendKeys.SendWait("{TAB}")
                  e.SuppressKeyPress = True
               Case Keys.Right
                  If .SelectionStart = .TextLength Then
                     'CursorPosSik = PWClass.CursorPosition
                     Routinen.CursorPosition = 1
                     SendKeys.SendWait("{TAB}")
                     e.SuppressKeyPress = True
                  End If
               Case Keys.Up
                  SendKeys.SendWait("+{TAB}")
                  e.SuppressKeyPress = True
               Case Keys.Left
                  If .SelectionStart = 0 Then
                     SendKeys.SendWait("+{TAB}")
                     e.SuppressKeyPress = True
                  End If
               Case Keys.Tab
                  'macht Tab
               Case Else
                  'nix
            End Select 'e.KeyData
         End With
      Catch ex As Exception
         Call Routinen.ErrMeldung(ex:=ex)
      End Try
      MyBase.OnKeyDown(e)
   End Sub 'OnKeyDown


   ''' <summary>
   ''' OnKeyPress
   ''' evt Fehler-Zeichen löschen + Dezimaltrennzeichen + Negativzeichen prüfen
   ''' </summary>
   Protected Overrides Sub OnKeyPress(e As KeyPressEventArgs)
      Dim ErrTxt As String = String.Empty
      Dim IdxDez As Integer = -1

      Try
         If [Char].IsDigit(e.KeyChar) Then              'wenn KeyChar = Zahl
            If myDecimal_Places > 0 And Me.Text.Contains(DecimalSeparator) Then
               IdxDez = Me.Text.IndexOf(DecimalSeparator)
               If Me.SelectionStart > IdxDez Then
                  If Me.Text.Substring(IdxDez + 1, Me.TextLength - (IdxDez + 1)).Length + 1 > myDecimal_Places Then
                     myErr_Text = ErrDecPlaces
                     e.Handled = True
                  End If
               End If
            End If
         Else                                                        'wenn nicht KeyChar = Zahl
            If e.KeyChar = DecimalSeparator Then                        'wenn KeyChar = Dezimaltrennzeichen
               If myDecimal_Places = 0 Then                                'wenn myDecimalPlaces = 0
                  myErr_Text = ErrNoDecPlaces
                  e.Handled = True
               ElseIf Me.SelectionStart < Me.TextLength Then                  'wenn Eingabe vor Textende
                  If Me.Text.Substring(Me.SelectionStart).Length > myDecimal_Places Then 'wenn Pos > myDecimalPlaces
                     myErr_Text = ErrDecPlaces
                     e.Handled = True
                  End If
               ElseIf Me.Text.Contains(DecimalSeparator) Then         ' wenn Trennzeichen vorhanden
                  Me.SelectionStart = Me.Text.IndexOf(DecimalSeparator) + 1
                  myErr_Text = ErrDezKommaDa
                  e.Handled = True
               End If
            ElseIf e.KeyChar = NegativeSign Then                      'wenn KeyChar = Negativzeichen
               If Not myMinus_Allowed Then                                    'wenn keine Negativzahlen
                  myErr_Text = ErrNoNegs
                  e.Handled = True
               ElseIf Me.Text.Contains(NegativeSign) Then                 'wenn Negativzeichen vorhanden
                  myErr_Text = ErrNegDa
               ElseIf Trim(Me.Text).Length > 0 And Me.SelectionStart > 0 Then 'wenn Länge >0 und Pos >0
                  myErr_Text = ErrNoNegHier
                  e.Handled = True
               End If
            ElseIf Asc(e.KeyChar) = 8 Then                                 'wenn KeyChar = BackSpace
               'nix
            Else
               e.Handled = True
            End If
         End If
      Catch ex As Exception
         Call Routinen.ErrMeldung(ex:=ex)
      End Try
      MyBase.OnKeyPress(e)
   End Sub 'OnKeyPress


#End Region 'OnKeyPress + OnKeyPress
   '***************************************************************************************************************************


   '***************************************************************************************************************************
#Region "Methoden beim Verlassen"
   '***************************************************************************************************************************
   ''' <summary>
   ''' OnValidating
   ''' EingabeText auf Minimum und Maximum prüfen
   ''' </summary>
   Protected Overrides Sub OnValidating(e As CancelEventArgs)
      Dim Ergo As Boolean = False

      Try
         If (Not (myMinValue = String.Empty) AndAlso CDbl(myMinValue) > CDbl(Me.Text)) Then
            Ergo = True
         Else
            If (Not (myMaxValue = String.Empty) AndAlso CDbl(myMaxValue) < CDbl(Me.Text)) Then
               Ergo = True
            End If
         End If
         If Ergo Then
            myErr_Text = ErrNoBetween
            Me.Text = myOld_Value
         End If
      Catch ex As Exception
         Call Routinen.ErrMeldung(ex:=ex)
      End Try
      e.Cancel = Ergo
   End Sub 'OnValidating


   ''' <summary>
   ''' OnValidated
   ''' Umwandling des EingabeText in Text mit Tausenderpunkt
   ''' </summary>
   Protected Overrides Sub OnValidated(e As EventArgs)
      Dim VorKomma As String = String.Empty, VorKommaRev As String = String.Empty, NachKomma As String = String.Empty
      Dim neutext As String = Nothing
      Dim i As Integer = 0, j As Integer = 0

      Try
         If myTausenderPunkt Then
            If Me.Text.IndexOf(DecimalSeparator) <= 0 Then
               VorKomma = Me.Text
            Else
               VorKomma = Me.Text.Substring(0, Me.Text.IndexOf(DecimalSeparator))
               NachKomma = Me.Text.Substring(Me.Text.IndexOf(DecimalSeparator) + 1)
            End If
            VorKommaRev = StrReverse(VorKomma)
            VorKommaRev = VorKommaRev.Replace(GroupSeparator, "")
            For i = 0 To VorKommaRev.Length - 1
               neutext &= VorKommaRev.Substring(i, 1)
               j = j + 1
               If j = 3 Then
                  j = 0
                  If i + 1 < VorKommaRev.Length Then
                     neutext &= GroupSeparator
                  End If
               End If
            Next i 'To VorKommaRev.Length
            Me.Text = StrReverse(neutext)
            If Not (NachKomma = String.Empty) Then
               Me.Text &= DecimalSeparator & NachKomma
            End If
         End If
      Catch ex As Exception
         Call Routinen.ErrMeldung(ex:=ex)
      End Try
   End Sub

#End Region 'Methoden beim Verlassen
   '***************************************************************************************************************************


   '***************************************************************************************************************************
#Region "Private Methoden"
   '***************************************************************************************************************************
   ''' <summary>
   ''' Set_Focused_Color
   ''' setzt Highlight-Rahmen um die aktuelle Textbox
   ''' </summary>
   Private Sub Set_Focused_Color(Optional AktStatus As Boolean = False)
      Dim tmpGraphics As Graphics = Nothing
      Dim tmpRect As Rectangle = Nothing
      Dim tmpColor As Color = Nothing

      Try
         tmpGraphics = Me.Parent.CreateGraphics
         tmpRect = New Rectangle(Me.Location.X - myPen_Width - 1, Me.Location.Y - myPen_Width - 1, _
                                       Me.Width + myPen_Width * 2 + 1, Me.Height + myPen_Width * 2 + 1)
         If AktStatus Then
            tmpColor = myColor_HighLight
         Else
            If IsNothing(Me.FindForm) Then
               tmpColor = myColor_Basis
            Else
               tmpColor = Me.FindForm.BackColor 'Color_Basis
            End If
         End If
         ControlPaint.DrawBorder(tmpGraphics, tmpRect, tmpColor, myPen_Width, ButtonBorderStyle.Solid, tmpColor, myPen_Width, _
                                                   ButtonBorderStyle.Solid, tmpColor, myPen_Width, ButtonBorderStyle.Solid, _
                                                   tmpColor, myPen_Width, ButtonBorderStyle.Solid)
      Catch ex As Exception
         Call Routinen.ErrMeldung(ex:=ex)
      End Try
   End Sub 'Set_Focused_Color

#End Region 'Private Methoden"
   '***************************************************************************************************************************


   '***************************************************************************************************************************
#Region "Methoden auf ContextMenu-Ereignisse"
   '***************************************************************************************************************************
   ''' <summary>
   ''' MenuItems
   ''' </summary>
   Private Sub myContext_Menu_CM_Clear() Handles myContext_Menu.CM_Clear
      Call Me.Clear()
   End Sub 'myContext_Menu_CM_Clear

   Private Sub myContext_Menu_CM_Copy() Handles myContext_Menu.CM_Copy
      Call Me.Copy()
   End Sub 'myContext_Menu_CM_Copy

   Private Sub myContext_Menu_CM_Cut() Handles myContext_Menu.CM_Cut
      Call Me.Cut()
   End Sub 'myContext_Menu_CM_Cut

   Private Sub myContext_Menu_CM_Paste() Handles myContext_Menu.CM_Paste
      Call Me.Paste()
   End Sub 'myContext_Menu_CM_Paste

   Private Sub myContext_Menu_CM_SelectAll() Handles myContext_Menu.CM_SelectAll
      Call Me.SelectAll()
   End Sub 'myContext_Menu_CM_SelectAll

   Private Sub myContext_Menu_CM_Undo() Handles myContext_Menu.CM_Undo
      Dim tmpUndos As Integer = -1

      With AllUndoValues
         tmpUndos = .Count
         If tmpUndos > 0 Then
            If Me.Text = .Last() Then '.Item(tmpUndos - 1) Then
               Call .RemoveAt(tmpUndos - 1)
               tmpUndos = .Count
            End If
         End If
         If tmpUndos > 0 Then
            Me.Text = .Last()
            Call .RemoveAt(tmpUndos - 1)
         End If
      End With 'AllUndoValues
   End Sub 'myContext_Menu_CM_Undo

#End Region 'Methoden auf ContextMenu-Ereignisse
   '***************************************************************************************************************************


End Class 'CC_NumBox
