﻿Public Class NumBox_KontextMenu
   Inherits ContextMenu

#Region "erzeugte Events"
   Public Event CM_Copy()
   Public Event CM_Cut()
   Public Event CM_Clear()
   Public Event CM_Paste()
   Public Event CM_SelectAll()
   Public Event CM_Undo()
#End Region 'erzeugte Events


#Region "Controls mit Events"
   Public WithEvents MenuItem_Copy As New MenuItem()
   Public WithEvents MenuItem_Paste As New MenuItem()
   Public WithEvents MenuItem_Cut As New MenuItem()
   Public WithEvents MenuItem_Delete As New MenuItem()
   Public WithEvents MenuItem_SelectAll As New MenuItem()
   Public WithEvents MenuItem_Undo As New MenuItem()
#End Region 'Controls mit Events


   '***************************************************************************************************************************
#Region "Constructor"
   '***************************************************************************************************************************
   Public Sub New()
      MyBase.New()
      Me.Name = "FirstMenu"
      Call Created_ContextMenu()
   End Sub

#End Region 'Constructor
   '***************************************************************************************************************************


   ''' <summary>
   ''' Created_ContextMenu
   ''' ContextMenu erstellen
   ''' </summary>
   Friend Sub Created_ContextMenu()
      Try
         With Me.MenuItems
            .Add(MenuItem_Undo) : .Add("-")
            .Add(MenuItem_Cut) : .Add(MenuItem_Copy) : .Add(MenuItem_Paste) : .Add("-")
            .Add(MenuItem_Delete) : .Add("-") : .Add(MenuItem_SelectAll)
         End With 'myContext_Menu.MenuItems
         With MenuItem_Copy
            .Name = "CMI_Copy"
            .Text = "Kopieren" : .ShowShortcut = True : .Shortcut = Shortcut.CtrlC
            AddHandler .Click, AddressOf MenuItem_Click
         End With 'MenuItem_Copy
         With MenuItem_Cut
            .Name = "CMI_Cut"
            .Text = "Ausschneiden" : .ShowShortcut = True : .Shortcut = Shortcut.CtrlX
            AddHandler .Click, AddressOf MenuItem_Click
         End With 'MenuItem_Cut
         With MenuItem_Delete
            .Name = "CMI_Del"
            .Text = "Löschen" : .ShowShortcut = True : .Shortcut = Shortcut.ShiftDel
            AddHandler .Click, AddressOf MenuItem_Click
         End With 'MenuItem_Delete
         With MenuItem_Paste
            .Name = "CMI_Paste"
            .Text = "Einfügen" : .ShowShortcut = True : .Shortcut = Shortcut.CtrlV
            AddHandler .Click, AddressOf MenuItem_Click
         End With 'MenuItem_Paste
         With MenuItem_SelectAll
            .Name = "CMI_SelectAll"
            .Text = "Alles auswählen" : .ShowShortcut = True : .Shortcut = Shortcut.CtrlA
            AddHandler .Click, AddressOf MenuItem_Click
         End With 'MenuItem_SelectAll
         With MenuItem_Undo
            .Name = "CMI_Undo"
            .Text = "Rückgängig Feld" : .ShowShortcut = True : .Shortcut = Shortcut.CtrlR
            AddHandler .Click, AddressOf MenuItem_Click
         End With 'MenuItem_Undo
      Catch ex As Exception
         Call Routinen.ErrMeldung(ex:=ex)
      End Try
   End Sub 'Created_ContextMenu


   Private Sub ContextMenu_Popup(sender As Object, e As EventArgs) Handles Me.Popup
      Dim iData As IDataObject = Nothing
      Dim iDataOK As Boolean = False
      Dim AktClpText As String = String.Empty
      Dim SelLength As Integer = -1
      Dim CanSelectOk As Boolean = False
      Dim CanUndoOk As Boolean = False

      Try
         iData = Clipboard.GetDataObject()
         Select Case Me.SourceControl.GetType.Name
            Case "CC_NumBox"
               iDataOK = iData.GetDataPresent(DataFormats.Text)
               If iDataOK Then
                  AktClpText = Clipboard.GetData(DataFormats.Text).ToString
                  If IsNumeric(AktClpText) Then
                     If AktClpText.IndexOf(",") = -1 Then
                        iDataOK = True
                     Else
                        iDataOK = DirectCast(Me.SourceControl, CC_NumBox).Text.Contains(",")
                     End If
                  End If
               End If
               With DirectCast(Me.SourceControl, CC_NumBox)
                  SelLength = .SelectionLength
                  CanSelectOk = CBool(.TextLength)
                  CanUndoOk = .CanUndo
               End With 'DirectCast(Me.SourceControl, CC_NumBox)
         End Select 'Me.SourceControl.GetType.Name

         MenuItem_Cut.Enabled = CBool(SelLength > 0)
         MenuItem_Copy.Enabled = MenuItem_Cut.Enabled
         MenuItem_Delete.Enabled = MenuItem_Cut.Enabled
         MenuItem_Paste.Enabled = iDataOK
         MenuItem_Undo.Enabled = CanUndoOk
         MenuItem_SelectAll.Enabled = CanSelectOk

      Catch ex As Exception
         Call Routinen.ErrMeldung(ex:=ex)
      End Try
   End Sub 'ContextMenu_Popup


   ''' <summary>
   ''' MenuItems
   ''' </summary>
   Private Sub MenuItem_Click(sender As Object, e As EventArgs)
      Select Case DirectCast(sender, MenuItem).Name
         Case "CMI_Copy"
            RaiseEvent CM_Copy()
         Case "CMI_Cut"
            RaiseEvent CM_Cut()
         Case "CMI_Paste"
            RaiseEvent CM_Paste()
         Case "CMI_Del"
            RaiseEvent CM_Clear()
         Case "CMI_SelectAll"
            RaiseEvent CM_SelectAll()
         Case "CMI_Undo"
            RaiseEvent CM_Undo()
      End Select 'DirectCast(sender, MenuItem).Name
   End Sub 'MenuItem_Click





End Class
